package com.auth

import android.app.Activity
import android.content.Intent
import android.os.Bundle
import android.widget.Toast
import androidx.localbroadcastmanager.content.LocalBroadcastManager
import com.android.dingtalk.share.ddsharemodule.DDShareApiFactory
import com.android.dingtalk.share.ddsharemodule.IDDAPIEventHandler
import com.android.dingtalk.share.ddsharemodule.IDDShareApi
import com.android.dingtalk.share.ddsharemodule.ShareConstant
import com.android.dingtalk.share.ddsharemodule.message.BaseReq
import com.android.dingtalk.share.ddsharemodule.message.BaseResp
import com.android.dingtalk.share.ddsharemodule.message.SendAuth

open class DDShareActivity : Activity(), IDDAPIEventHandler {
    
    private var ddShareApi: IDDShareApi? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        ddShareApi = DDShareApiFactory.createDDShareApi(this, "", false)
        ddShareApi?.handleIntent(intent, this)
    }

    companion object {
        const val BROADCAST = "com.dingding.auth"
    }

    override fun onResp(p0: BaseResp?) {
        val errCode: Int? = p0?.mErrCode
        val errMsg: String? = p0?.mErrStr
        if (p0?.type == ShareConstant.COMMAND_SENDAUTH_V2 && p0 is SendAuth.Resp) {
            when (errCode) {
                BaseResp.ErrCode.ERR_OK -> {
                    val intent = Intent(BROADCAST)
                    intent.putExtra("type", 1)
                    intent.putExtra("code", (p0 as SendAuth.Resp).code)
                    LocalBroadcastManager.getInstance(this).sendBroadcast(intent)
                }
                BaseResp.ErrCode.ERR_USER_CANCEL -> {
                    val intent = Intent(BROADCAST)
                    intent.putExtra("type", 0)
                    intent.putExtra("code", errMsg)
                    LocalBroadcastManager.getInstance(this).sendBroadcast(intent)
                }
                else -> Toast.makeText(this, "授权异常$errMsg", Toast.LENGTH_SHORT).show()
            }
        }
        finish()
    }

    override fun onReq(p0: BaseReq?) {

    }

}