package com.uupt.dingauth

import android.app.Activity
import android.content.Context
import androidx.annotation.NonNull
import com.auth.DingAuth
import com.auth.OnAuthCallback

import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.embedding.engine.plugins.activity.ActivityAware
import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import io.flutter.plugin.common.PluginRegistry.Registrar

/** DingauthPlugin */
class DingauthPlugin : FlutterPlugin, MethodCallHandler, ActivityAware {
    /// The MethodChannel that will the communication between Flutter and native Android
    ///
    /// This local reference serves to register the plugin with the Flutter Engine and unregister it
    /// when the Flutter Engine is detached from the Activity
    private lateinit var channel: MethodChannel

    override fun onAttachedToEngine(@NonNull flutterPluginBinding: FlutterPlugin.FlutterPluginBinding) {
        channel = MethodChannel(flutterPluginBinding.binaryMessenger, "dingauth")
        channel.setMethodCallHandler(this)
    }

    private var activity: Context? = null;

    fun init(activity: Activity?) {
        this.activity = activity;
    }

    override fun onMethodCall(@NonNull call: MethodCall, @NonNull result: Result) {
        if (call.method == "getDingAuth") {
            var dingAppId: String = call.arguments.toString();
            val callback = object : OnAuthCallback {
                override fun onSuccess(code: String) {
                    result.success(code)
                }

                override fun onFailed(code: String) {
                    result.success(code)
                }
            }
            if (this.activity != null) {
                DingAuth(this.activity!!, dingAppId).doAuth(callback)
            } else {
                result.notImplemented()
            }
        } else {
            result.notImplemented()
        }
    }

    override fun onDetachedFromEngine(@NonNull binding: FlutterPlugin.FlutterPluginBinding) {
        channel.setMethodCallHandler(null)
    }

    //region ActivityAware
    override fun onAttachedToActivity(binding: ActivityPluginBinding) {
        init(binding.activity)
    }

    override fun onDetachedFromActivity() {
        this.activity = null;
    }

    override fun onReattachedToActivityForConfigChanges(binding: ActivityPluginBinding) {

    }

    override fun onDetachedFromActivityForConfigChanges() {

    }
    //endregion
}
