#import "DingauthPlugin.h"

#import "DTOpenKit.h"
#if __has_include(<dingauth/dingauth-Swift.h>)
#import <dingauth/dingauth-Swift.h>
#else
// Support project import fallback if the generated compatibility header
// is not copied when this plugin is created as a library.
// https://forums.swift.org/t/swift-static-libraries-dont-copy-generated-objective-c-header/19816
//#import "dingauth-Swift.h"
#endif


@interface DingauthPlugin()<DTOpenAPIDelegate>
@property (readwrite,copy,nonatomic) FlutterResult callback;
@end

@implementation DingauthPlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
    FlutterMethodChannel *messageChannel = [FlutterMethodChannel methodChannelWithName:@"ding_auth" binaryMessenger:[registrar messenger]];
    DingauthPlugin *instance = [[DingauthPlugin alloc] init];
    [registrar addMethodCallDelegate:instance channel:messageChannel];
    [registrar addApplicationDelegate:instance];
    
}


- (void)handleMethodCall:(FlutterMethodCall *)call result:(FlutterResult)result {
    ///授权
    if ([@"getDingAuth" isEqualToString:call.method]) {
        [DTOpenAPI registerApp:call.arguments];
        [self dingtalkLogin];
        self.callback = ^(id accessCode) {
            if (result) {
                result(accessCode);
            }
        };
    } else {
        result(FlutterMethodNotImplemented);
    }
}


- (void)dingtalkLogin {
    DTAuthorizeReq *authReq = [DTAuthorizeReq new];
    authReq.bundleId = @"com.uupt.urban";
    BOOL result = [DTOpenAPI sendReq:authReq];
    if (result) {
        NSLog(@"授权登录 发送成功.");
    }else {
        NSLog(@"授权登录 发送失败.");
    }
}

- (void)onResp:(DTBaseResp *)resp{
  //授权登录回调参数为DTAuthorizeResp，accessCode为授权码
    if ([resp isKindOfClass:[DTAuthorizeResp class]]) {
        DTAuthorizeResp *authResp = (DTAuthorizeResp *)resp;
        NSString *accessCode = authResp.accessCode;
        if (self.callback) {
            self.callback(accessCode);// 将授权码交给服务端做SSO
        }
    }
}

- (BOOL)application:(UIApplication *)app openURL:(NSURL *)url options:(NSDictionary<UIApplicationOpenURLOptionsKey, id> *)options {
    if ([DTOpenAPI handleOpenURL:url delegate:self]) {
        return YES;
    }
    return NO;
}

- (BOOL)application:(UIApplication *)application handleOpenURL:(NSURL *)url {
    if ([DTOpenAPI handleOpenURL:url delegate:self]) {
        return YES;
    }
    return NO;
}

- (BOOL)application:(UIApplication *)application openURL:(NSURL *)url sourceApplication:(NSString *)sourceApplication annotation:(id)annotation {
    if ([DTOpenAPI handleOpenURL:url delegate:self]) {
        return YES;
    }
    return NO;
}
@end
